#ifndef _Cluster_
#define _Cluster_

#include <iostream>

using namespace std;

#include "../datastruct.h"
#include "../SimFunc/SimDist.h"
#include "FTable.h"

typedef set<unsigned> ContCluster;

class Cluster {
private:
  ContCluster *index;
  unsigned pivot; // index in the data vector
  SimType radius;
  FTable *ftable;

public:
  Cluster();
  Cluster(const Cluster& c);
  ~Cluster();

  Cluster& operator=(const Cluster& c);

  void set_pivot(const unsigned& p);
  void set_radius(const SimType r);

  const unsigned get_pivot() const;
  const SimType get_radius() const;
  const FTable& get_ftable() const;

  const size_t size() const;
  ContCluster::const_iterator begin() const;
  ContCluster::const_iterator end() const;
  void clear();

  void build_ftable(VectString *data);
  bool improve(VectString& data);  

  ContCluster::const_iterator find(unsigned idx) const;
  void insert(unsigned idx);
  void insert(unsigned idx, const SimVect vect);
  void erase(unsigned idx, const SimVect vect);

  friend ostream& operator<<(ostream& out, const Cluster& c);
  friend istream& operator>>(istream& in, Cluster& c);
};

typedef vector<Cluster> VectCluster;
typedef VectCluster::iterator VectClusterIt;

#endif
