#include "FTable.h"

FTable::FTable() {
  cont=new ContFTable();
}

FTable::FTable(const FTable& t) {
  cont=new ContFTable();
  *cont=*t.cont;
}

FTable::~FTable() {
  delete cont;
}

FTable& FTable::operator=(const FTable& t) {
  if (this==&t)
    return *this;
  *cont=*t.cont;
  return *this;
}

const size_t FTable::size() const {
  return cont->size();
}

void FTable::insert(SimVect vect)
{
  (*cont)[vect]++;
}

void FTable::erase(SimVect vect)
{
  if (cont->find(vect) != cont->end()) 
    {
      if ((*cont)[vect] != 0) 
	{
	  (*cont)[vect]--;
	}
      if ((*cont)[vect] == 0) 
	{
	  cont->erase(vect);
	}
    }
}

const ContFTable::iterator FTable::begin() const {
  return cont->begin();
}

const ContFTable::iterator FTable::end() const {
  return cont->end();
}

ostream& operator<<(ostream& out, const FTable& t)
{
  out << t.cont->size() << endl;
  for (ContFTable::const_iterator it = t.cont->begin(); it != t.cont->end(); ++it) 
    {
      out << it->first << "\t" << it->second << endl;
    }
  return out;
}

istream& operator>>(istream& in, FTable& t)
{
  unsigned sz;
  in >> sz;
  for (unsigned i = 0; i < sz; i++) 
    {
      SimVect vect;
      unsigned cnt;
      in >> vect >> cnt;
      (*t.cont)[vect] = cnt;
    }
  return in;
}
