#ifndef _FTable_
#define _FTable_

#include <iostream>
#include <iterator>
#include <map>

using namespace std;

#include "../icstring.h"
#include "../SimFunc/SimVect.h"

typedef map<SimVect, unsigned> ContFTable;

class FTable {
private:
  ContFTable *cont;
public:
  FTable();
  FTable(const FTable& t);
  ~FTable();

  FTable& operator=(const FTable& t);

  const size_t size() const;

  void insert(SimVect vect);
  void erase(SimVect vect);

  const ContFTable::iterator begin() const;
  const ContFTable::iterator end() const;

  friend ostream& operator<<(ostream& out, const FTable& t);
  friend istream& operator>>(istream& in, FTable& t);
};

#endif
