#include <iostream>
#include <iterator>
#include <vector>
#include <set>
#include <fstream>
#include <string>
#include <ctime>

using namespace std;

#include "common.h"
#include "Duplicate.h"

#include "SimFunc/EditDist.h"

void insertDuplicates() {
  const unsigned data_set_size  = 100000;
  const unsigned start_set_size =  5000;
  int percent_dup = 100; // this is not const and not int in order not to generate a warining in if bellow
  const unsigned max_dup = 40; // # of duplicates is from 1 to max_dup
  const unsigned max_changes = 4; // # nr of changes if form 1 to max_changes

  string
    fin_name  = "/extra/rvernica0/projects/datasets/imdb/actors.name.100k.txt",
    fout_name = "/extra/rvernica0/projects/datasets/imdb/actors.name.dup.100k.txt";

  ifstream fin(fin_name.c_str()); 
  if (!fin) { cerr<<"can't open input file \""<<fin_name<<"\""<<endl; exit(EXIT_FAILURE); }
  
  ofstream fout(fout_name.c_str());
  if (!fout) { cerr<<"can't open output file \""<<fout_name<<"\""<<endl; exit(EXIT_FAILURE); }

  srand(static_cast<unsigned>(time(NULL)));

  cout<<"reading records form file \""<<fin_name<<"\"..."<< endl;
  cout<<"writing records to   file \""<<fout_name<<"\"..."<< endl;
  string s;
  while (getline(fin, s)) {
    if (rand() % 1000 < static_cast<int>(static_cast<float>(start_set_size) / data_set_size*1000)) {
      // the current string is selected
      fout << s << endl;
      // should it be duplicated
      if (percent_dup==100 ||
	  rand()%100 < percent_dup) {
	// now generate duplicates
	const unsigned no_dup = 1 + rand() % max_dup;
	for (unsigned i=0; i<no_dup; i++) {
	  string s_dup=s;
	  EditDist_modif(s_dup, 1 + rand() % max_changes);
	  fout << trim(s_dup) << endl;
	}
      }
    }
  }
}

void selectLastName() {
  string
    fin_name="imdb.txt",
    fout_name="imdb-ln.txt";

  ifstream fin(fin_name.c_str());
  if (!fin) { cerr<<"can't open input file \""<<fin_name<<"\""<<endl; exit(EXIT_FAILURE); }
  ofstream fout(fout_name.c_str());
  if (!fout) { cerr<<"can't open output file \""<<fout_name<<"\""<<endl; exit(EXIT_FAILURE); }

  cout<<"reading records form file \""<<fin_name<<"\"..."<< endl;
  cout<<"reading records form file \""<<fout_name<<"\"..."<< endl;
  string s;
  while (getline(fin, s)) {
    size_t start, end;
    if (s.find("Sr.")==s.length()-3 ||
	s.find("Jr.")==s.length()-3) {
      size_t i=s.rfind(' ');
      size_t j=s.rfind(' ', i-1);
      start=j+1;
      end=i-start;
    } else {
      size_t i=s.rfind(' ');
      start=i+1;
      end=s.length()-i-1;
    }
    fout<<s.substr(start, end)<<endl;
  }
}
