#include <string>
#include <vector>
#include <set>
#include <iterator>
#include <iostream>

using namespace std;

#include "../common.h"
#include "../SimFunc/SimDist.h"
#include "Predicate.h"
#include "Record.h"
#include "DecTree.h"

void DecTreeNode::setRelErr() 
{
  rel_err=0;
  unsigned count=0;
  for(VectRecordIt it=examples.begin(); it!=examples.end(); count++, rel_err+=it->rel_err, it++);
  // assumes that all examples have an rel_err (!= -1)
  rel_err/=count;
}

void DecTreeNode::split() 
{
  left=new DecTreeNode();
  right=new DecTreeNode();  
  for (VectRecordIt it=examples.begin(); it!=examples.end(); it++) {
    if (testCond.test(*it)) {
      left->examples.push_back(*it);
    }
    else {
      right->examples.push_back(*it);
    }
  }
  examples.clear();
  left->setRelErr();
  right->setRelErr();
}

int main(int argc, char* argv[]) 
{
  VectRecord dataset;

  Record a;
  a=Record("a", 3, 20.5, 15); dataset.push_back(a);
//   cout<<a<<endl;
  a=Record("b", 3, 12.2, 10); dataset.push_back(a);
  a=Record("c", 4, 10.1, 22); dataset.push_back(a);
  a=Record("d", 4, 13.5, 29); dataset.push_back(a);

//   cout<<dataset;
  
  DecTreeNode *root=new DecTreeNode();
  root->examples.insert(root->examples.end(), dataset.begin(), dataset.end());
  root->setRelErr();
  root->testCond=TestCond(Record_getThr, 3);

  cout<<*root<<endl;
  cout<<root->examples<<endl;

  root->split();
  
  cout<<*root<<endl;
  cout<<*(root->left)<<endl;
  cout<<root->left->examples<<endl;
  cout<<*(root->right)<<endl;
  cout<<root->right->examples<<endl;

  return 0;
}

