#ifndef _DecTree_
#define _DecTree_

class TestCond
{
public:
  Record_Func* testFunc;
  float testValue;

  TestCond();
  TestCond(Record_Func* testFunc, float testValue);

  bool test(Record r);
};

class DecTreeNode 
{
public:
  TestCond testCond;
  DecTreeNode *left, *right;
  VectRecord examples;
  float rel_err;

  DecTreeNode();
  ~DecTreeNode();

  void setRelErr();
  void split();

  friend ostream& operator<<(ostream& out, const DecTreeNode& node);
};

inline ostream& operator<<(ostream& out, const DecTreeNode& node) 
{
  return out<<node.examples.size()<<"\t"<<node.rel_err;
}

inline TestCond::TestCond() 
{
}

inline TestCond::TestCond(Record_Func* f, float v): testFunc(f), testValue(v) 
{
}

inline bool TestCond::test(Record r) 
{
  return (*testFunc)(r)<=testValue;
}

inline DecTreeNode::DecTreeNode(): left(0), right(0)
{
}

inline DecTreeNode::~DecTreeNode() 
{
  if (left) {
    delete left;
    left=0;
  }
  if (right) {
    delete right;
    right=0;
  }
}

#endif
