#include "ErrorCorr.h"

void ErrorCorr::buildDT() 
{
  unsigned sum_len=0;
  SimType sum_thr=0;
  float sum_est=0;
  
  for (VectRecordIt it=dataset.begin(); it!=dataset.end(); it++) {
    sum_len+=it->query.length();
    sum_thr+=it->dist;
    sum_est+=it->est;
  }

  unsigned size=dataset.size();
  avg_len=static_cast<float>(sum_len)/size;
  avg_thr=static_cast<float>(sum_thr)/size;
  avg_est=sum_est/size;

  unsigned count[8];
  float sum_err[8];
  
  for (unsigned i=0; i<8; i++) {
    count[i]=0;
    sum_err[i]=0;
  }

  for (VectRecordIt it=dataset.begin(); it!=dataset.end(); it++) {
    unsigned pos=getPos(*it);
    count[pos]++;
    sum_err[pos]+=it->rel_err;  // assumes that all the entries in the dataset have rel_err
  }  

  for (unsigned i=0; i<8; i++) {
    if (count[i]) {
      err[i]=sum_err[i]/count[i];
    }
    else {
      err[i]=0;
    }
  }  
}

unsigned ErrorCorr::getPos(Record r) const
{
  unsigned pos=0;
  if (static_cast<float>(r.dist)<=avg_thr) {
  }
  else {
    pos += 4;
  }
  if (static_cast<float>(r.query.length())<=avg_len) {
  }
  else {
    pos += 2;
  }
  if (r.est<=avg_est) {
  }
  else {
    pos += 1;
  }
  return pos;
}

ostream& ErrorCorr::info(ostream& out) 
{
  out << "ErrorCorr" << endl << "---" << endl;
  out << "ErrorCorr record size\t" << RECORD_SIZE << endl;
  return out << endl;
}

ostream& operator<<(ostream& out, const ErrorCorr& errorCorr) 
{
  out<<errorCorr.avg_thr<<endl;
  out<<errorCorr.avg_len<<endl;
  out<<errorCorr.avg_est<<endl<<endl;
  for (unsigned i=0; i<8; i++) {
    out<<errorCorr.err[i]<<" ";
  }
  out<<endl;
  return out;
}

istream& operator>>(istream& in, ErrorCorr& errorCorr) 
{
  in>>errorCorr.avg_thr;
  in>>errorCorr.avg_len;
  in>>errorCorr.avg_est;
  for (unsigned i=0; i<8; i++) {
    in>>errorCorr.err[i];
  }
  return in;
}

/*
int main(int argc, char* argv[]) 
{
  VectRecord dataset;

  Record a;
  a=Record("a", 3, 20.5, 15); dataset.push_back(a);
  a=Record("b", 3, 12.2, 10); dataset.push_back(a);
  a=Record("c", 4, 10.1, 22); dataset.push_back(a);Re
  a=Record("d", 4, 14.7, 29); dataset.push_back(a);
  a=Record("aa", 3, 22.5, 15); dataset.push_back(a);
  a=Record("bb", 3, 9.2, 10); dataset.push_back(a);
  a=Record("cc", 4, 12.1, 22); dataset.push_back(a);
  a=Record("dd", 4, 15.2, 29); dataset.push_back(a);

  cout<<dataset;

  ErrorCorr er=ErrorCorr(dataset);
  cout<<er;

  return 0;
}
*/  
