#ifndef _ErrorCorr_
#define _ErrorCorr_

#include <iostream>

using namespace std;

#include "Record.h"

const unsigned RECORD_SIZE = 300;

class ErrorCorr 
{
private:
  VectRecord dataset;
  float avg_len, avg_thr, avg_est;
  float err[8];
  
public:
  ErrorCorr();
  ErrorCorr(VectRecord& dataset);

  float getError(Record r) const;

  void buildDT();

  static ostream& info(ostream& out);

private:
  unsigned getPos(Record r) const;

  friend ostream& operator<<(ostream& out, const ErrorCorr& errorCorr);
  friend istream& operator>>(istream& in, ErrorCorr& errorCorr);
};

inline ErrorCorr::ErrorCorr() 
{
}

inline ErrorCorr::ErrorCorr(VectRecord& d): dataset(d) 
{
  buildDT();
}

inline float ErrorCorr::getError(Record r) const 
{
  return err[getPos(r)];
}

// WEKA

// inline float ErrorCorr::getError(Record r) 
// {
//   unsigned
//     predicate_string_length = r.query.length(), 
//     count_clusters = r.cnt_cluster, 
//     count_ppdpairs = r.cnt_ppdpair;
//   SimType predicate_threshold = r.dist;
//   float selectivity_estimation = r.est;

//   return
//     0;
// }

// const string error_correction_method = "REPTree.10000";

#endif
