#ifndef _Predicate_
#define _Predicate_

#include <iostream>
#include <iterator>
#include <vector>

using namespace std;

#include "../SimFunc/SimDist.h"

#if _SimDist_ == 1
extern unsigned THRESHOLD_MIN;
extern unsigned THRESHOLD_MAX;
#elif _SimDist_ == 2
extern float THRESHOLD_MIN;
extern float THRESHOLD_MAX;
#endif

class Predicate 
{
public:
  icstring query;
  SimType dist;
  unsigned freq;

  Predicate();
  Predicate(icstring q, SimType d);

  friend ostream& operator<<(ostream& out, const Predicate& p);
  friend istream& operator>>(istream& in, Predicate& p);
};

typedef vector<Predicate> VectPredicate;
typedef VectPredicate::iterator VectPredicateIt;

inline ostream& operator<<(ostream& out, const VectPredicate& v) 
{
  out<<static_cast<unsigned>(v.size())<<endl<<endl;
  copy(v.begin(), v.end(), ostream_iterator<Predicate>(out, "\n"));
  return out;
}

istream& operator>>(istream& in, Predicate& p);
istream& operator>>(istream& in, VectPredicate& v);

inline Predicate::Predicate(): query(""), dist(SIM_TYPE_MIN) 
{
}

inline Predicate::Predicate(icstring q, SimType d): query(q), dist(d) 
{
}

inline ostream& operator<<(ostream& out, const Predicate& p) 
{
  return out<<p.query<<"\t"<<p.dist << "\t" << p.freq;
}

#endif
