#ifndef _Test_
#define _Test_

#include "../Cluster/Clusters.h"
#include "Predicate.h"
#include "ErrorCorr.h"

class Test 
{
private:
  VectString *data;
  Clusters *clusters;
  VectPredicate vectTest;
  const ErrorCorr *errorCorr;

  float sum_rel_err, sum_rel_err_cor, sum_time;
  unsigned no_rel_err, buck[10];
	bool doBuck;

public:
  Test(VectString* dat, Clusters* clust, bool doBuck = false);

  void create(const SetUnsigned& setQuery);
  void test();

  size_t size() const;
  void setErrorCorr(const ErrorCorr& errorCorr);

  ostream& info(ostream& out) const;

  friend ostream& operator<<(ostream& out, const Test& t);
  friend istream& operator>>(istream& in, Test& t);
};

inline size_t Test::size() const 
{
  return vectTest.size();
}

inline ostream& operator<<(ostream& out, const Test& t) 
{
  return out << t.vectTest;
}

inline istream& operator>>(istream& in, Test& t) 
{
  return in >> t.vectTest;
}

#endif

