#include <iostream>

using namespace std;

#include "../icstring.h"

class Update 
{
public:
  unsigned id;
  icstring str;
  
  Update()
  {
  }
  
  Update(unsigned id): id(id)
  {
  }
  
  Update(unsigned id, icstring str): id(id), str(str)
  {
  }
  
  friend ostream& operator<<(ostream& out, const Update& u)
  {
    return out << u.id << "\t" << u.str;
  }
  
  friend istream& operator>>(istream& in, Update& u)
  {
    return in >> u.id >>  u.str;
  }
};

typedef vector<Update> ContUpdates;

inline ostream& operator<<(ostream& out, const ContUpdates& c)
{
  out << c.size() << endl << endl;
  for (ContUpdates::const_iterator it = c.begin(); it != c.end(); ++it)
    {
      out << *it << endl;
    }
  return out;
}

inline istream& operator>>(istream& in, ContUpdates& c)
{
  unsigned sz;
  in >> sz;
  for (unsigned i = 0; i < sz; i++)
    {
      Update u;
      in >> u;
      c.push_back(u);
    }
  return in;
}



