#include "ALL_RAND.h"

ALL_RAND::ALL_RAND(VectString *d, Clusters *c, ContQueryPivot *q): PPDSample(d, c, q) 
{
	cout << "---check ALL_RAND---" << endl;

  // init - sample
  sample = Sample(max(1u, static_cast<unsigned>(SAMPLE_PERCENT * data->size())), data->size());

  // init - loop
  sample_it=sample.begin();  
  cluster_it=clusters->begin_cluster();
  string_it=cluster_it->begin();
}

void ALL_RAND::step() 
{
  string_it++;
  if (string_it==cluster_it->end()) {
    ++cluster_it;
    if (cluster_it == clusters->end_cluster())
      {
	sample_it++;
	if (sample_it==sample.end()) 
	  {
	    return;
	  }
	cluster_it = clusters->begin_cluster();
      }
    string_it=cluster_it->begin();
  }
}

bool ALL_RAND::has_next() const 
{
  if (sample_it != sample.end()) 
    return true;
  return false;
}

PPDTriple ALL_RAND::next() 
{
  const unsigned q=*sample_it;
  const unsigned p=cluster_it->get_pivot();
  const unsigned s=*string_it;

  PPDTriple triple=PPDTriple(
			     q,
			     p,
			     s,
			     SimVect((*data)[q], (*data)[p]),
			     SimVect((*data)[p], (*data)[s]),
			     SimDist((*data)[q], (*data)[s]));

  // increment
  step();

  return triple;
}
