#include "CLOSE_LEX.h"

class Cmp_idx
{
private:
  const VectString *data;
public:
  Cmp_idx(const VectString *d): data(d) 
  {
  }
  bool operator()(unsigned idx1, unsigned idx2)
  {
    return (*data)[idx1] < (*data)[idx2];
  }
};

CLOSE_LEX::CLOSE_LEX(VectString *d, Clusters *c, ContQueryPivot *q): PPDSample(d, c, q) 
{
	cout << "---check CLOSE_LEX---" << endl;

  // init - sample
  index.reserve(d->size());
  for (unsigned i = 0; i < d->size(); i++) index.push_back(i);
  sort(index.begin(), index.end(), Cmp_idx(data));
  sample = Sample(max(1u, static_cast<unsigned>(data->size() * SAMPLE_PERCENT)), data->size());

  // init - loop
  sample_it=sample.begin();
  build_queue();
  unsigned j=samplePair.begin()->index;
  samplePair.erase(samplePair.begin());
  cluster=clusters->get_cluster(j);
  string_it=cluster.begin();
}

void CLOSE_LEX::step() 
{
  string_it++;
  if (string_it==cluster.end()) {
    if (samplePair.empty()) {
      sample_it++;
      if (sample_it==sample.end()) 
	{
	  return;
	}
      build_queue();
    }
    unsigned i=samplePair.begin()->index;
    samplePair.erase(samplePair.begin());
    cluster=clusters->get_cluster(i);
    string_it=cluster.begin();
  }
}

bool CLOSE_LEX::has_next() const 
{
  if (sample_it!=sample.end())
    return true;
  return false;
}

PPDTriple CLOSE_LEX::next() 
{
  const unsigned q=index[*sample_it];
  const unsigned p=cluster.get_pivot();
  const unsigned s=*string_it;

  PPDTriple triple=PPDTriple(
			     q,
			     p,
			     s,
			     SimVect((*data)[q], (*data)[p]),
			     SimVect((*data)[p], (*data)[s]),
			     SimDist((*data)[q], (*data)[s]));

  // increment
  step();

  return triple;
}

void CLOSE_LEX::build_queue() 
{
  const unsigned queue_size=QUEUE_SIZE;
  for (unsigned i=0; i<clusters->size_cluster(); i++) {
    const unsigned p=clusters->get_cluster(i).get_pivot();
    const unsigned q=*sample_it;
    SimType dist=SimDist((*data)[q], (*data)[p]);
    if (samplePair.size()<queue_size || dist<samplePair.begin()->dist) {
      samplePair.insert(IndexEntry(i, dist));
      if (samplePair.size()>queue_size)
	samplePair.erase(samplePair.begin());
    }
  }
}
