#include "CLOSE_RAND.h"

CLOSE_RAND::CLOSE_RAND(VectString *d, Clusters *c, ContQueryPivot *q): PPDSample(d, c, q)
{
	cout << "---check CLOSE_RAND---" << endl;

  // init - sample
  sample = Sample(max(1u, static_cast<unsigned>(SAMPLE_PERCENT * data->size())), data->size());

  // init - loop
  sample_it=sample.begin();
  build_queue();
  unsigned j=samplePair.begin()->index;
  samplePair.erase(samplePair.begin());
  cluster=clusters->get_cluster(j);
  string_it=cluster.begin();
}

void CLOSE_RAND::step() 
{
  string_it++;
  if (string_it == cluster.end()) {
    query_pivot->insert(std::make_pair(cluster.get_pivot(), 
                                       QueryVect(*sample_it, SimVect((*data)[*sample_it], 
                                                                     (*data)[cluster.get_pivot()]))));
    if (samplePair.empty()) {
      sample_it++;
      if (sample_it == sample.end()) 
        {
          return;
        }
      build_queue();
    }
    unsigned i=samplePair.begin()->index;
    samplePair.erase(samplePair.begin());
    cluster=clusters->get_cluster(i);
    string_it=cluster.begin();
  }
}

bool CLOSE_RAND::has_next() const 
{
  if (sample_it != sample.end())
    return true;
  return false;
}

PPDTriple CLOSE_RAND::next() 
{
  const unsigned q=*sample_it;
  const unsigned p=cluster.get_pivot();
  const unsigned s=*string_it;

  PPDTriple triple=PPDTriple(q,
                             p,
                             s,
                             SimVect((*data)[q], (*data)[p]),
                             SimVect((*data)[p], (*data)[s]),
                             SimDist((*data)[q], (*data)[s]));

  // increment
  step();

  return triple;
}

void CLOSE_RAND::build_queue() 
{
  const unsigned queue_size = QUEUE_SIZE;
  for (unsigned i = 0; i < clusters->size_cluster(); i++) {
    const unsigned p = clusters->get_cluster(i).get_pivot();
    const unsigned q = *sample_it;
    SimType dist = SimDist((*data)[q], (*data)[p]);
    if (samplePair.size() < queue_size || dist < samplePair.begin()->dist) {
      samplePair.insert(IndexEntry(i, dist));
      if (samplePair.size() > queue_size) 
        {
          samplePair.erase(samplePair.begin());
        }
    }
  }
}
