#ifndef _IndexEntry_
#define _IndexEntry_

#include <set>

using namespace std;

#include "../SimFunc/SimDist.h"

class IndexEntry
{
public:
  unsigned index;
  SimType dist;
 
  IndexEntry(unsigned i, SimType d);

  friend ostream& operator<<(ostream& out, const IndexEntry& e);
  friend bool operator<(const IndexEntry& left, const IndexEntry& right);
};

typedef set<IndexEntry> ContIndexEntry;

inline IndexEntry::IndexEntry(unsigned i, SimType d): index(i), dist(d) 
{
}

inline bool operator<(const IndexEntry& left, const IndexEntry& right) 
{
  if (&left==&right)
    return false;
  if (left.dist != right.dist) 
    {
      return left.dist < right.dist;
    }
  return left.index < right.index;
}

inline ostream& operator<<(ostream& out, const IndexEntry& e)
{
  return out << e.index << "\t" << e.dist;
}

#endif
