#include "PPDEntry.h"

istream& operator>>(istream& in, ContPPDEntry& c) {
	unsigned n;
	in>>n;
	for (unsigned i=0; i<n; i++) {
		PPDEntry e;
		in>>e;
		c.insert(e);
	}
	return in;
}

#ifdef _Sim_EditVect_

void PPDEntry::serialize(ofstream &  out) const
{
//   vect1.serialize(out);
//   vect2.serialize(out);
//   out.write(reinterpret_cast<const char *>(&dist_m), sizeof(SimType));

  // < I, D, S > < I, D, S > D   in [0, 15]
  // unsigned -  32bit

  unsigned data = 0;
  
  data |= 0x0000000F & vect1.ins;
  data |= 0x000000F0 & (vect1.del << 4);
  data |= 0x00000F00 & (vect1.sub << 8);
  data |= 0x0000F000 & (vect2.ins << 12);
  data |= 0x000F0000 & (vect2.del << 16);
  data |= 0x00F00000 & (vect2.sub << 20);
  data |= 0x0F000000 & (dist_m << 24);

  out.write(reinterpret_cast<const char *>(&data), sizeof(unsigned));
  out.write(reinterpret_cast<const char *>(&count_e), sizeof(unsigned));

//   unsigned fract_u = static_cast<unsigned>(fract * 10000);
//   unsigned char buf[2];
//   buf[0] = 0xFF & fract_u;
//   buf[1] = 0xFF & (fract_u >> 8);
//   out.write(reinterpret_cast<const char *>(&buf), sizeof(unsigned char) * 2);

  out.write(reinterpret_cast<const char *>(&fract), sizeof(float));
}

void PPDEntry::deserialize(ifstream &  in) 
{
//   vect1.deserialize(in);
//   vect2.deserialize(in);
//   in.read(reinterpret_cast<char *>(&dist_m), sizeof(SimType));

  unsigned data = 0;

  in.read(reinterpret_cast<char *>(&data), sizeof(unsigned));

  vect1.ins = data & 0x0000000F;
  vect1.del = (data & 0x000000F0) >> 4;
  vect1.sub = (data & 0x00000F00) >> 8;
  vect2.ins = (data & 0x0000F000) >> 12;
  vect2.del = (data & 0x000F0000) >> 16;
  vect2.sub = (data & 0x00F00000) >> 20;
  dist_m    = (data & 0x0F000000) >> 24;

  in.read(reinterpret_cast<char *>(&count_e), sizeof(unsigned));

//   unsigned fract_u = 0;
//   unsigned char buf[2];
//   in.read(reinterpret_cast<char *>(&buf), sizeof(unsigned char) * 2);
//   fract_u = (buf[1] << 8) | buf[0];
//   fract = static_cast<float>(fract_u) / 10000;

  in.read(reinterpret_cast<char *>(&fract), sizeof(float));
}

#endif

