#ifndef _PPDPair_
#define _PPDPair_

#include <iostream>
#include <iterator>
#include <set>

using namespace std;

#include "../SimFunc/SimVect.h"

class PPDPair {
public:
  SimVect vect1, vect2;
  SimType max_d;
  unsigned count_p;

  PPDPair(SimVect v1, SimVect v2, SimType m_d);

  friend ostream& operator<<(ostream& out, const PPDPair& p);
  friend bool operator<(const PPDPair& left, const PPDPair& right);
};

typedef set<PPDPair> SetPPDPair;
typedef SetPPDPair::iterator SetPPDPairIt;

inline PPDPair::PPDPair(SimVect v1, SimVect v2, SimType m_d): vect1(v1), vect2(v2), max_d(m_d), count_p(1) {
}

inline ostream& operator<<(ostream& out, const PPDPair& p) {
  return out<<'['<<p.vect1<<','<<p.vect2<<','<<p.max_d<<','<<p.count_p<<']';
}

inline bool operator<(const PPDPair& left, const PPDPair& right) {
  if (&left==&right)
    return false;
  if (left.vect1!=right.vect1)
    return left.vect1<right.vect1;
  return left.vect2<right.vect2;
}

#endif
