#ifndef _PPDSample_
// #define _PPDSample_ 2
#define _PPDSample_ Sample_Method
// 1: ALL_RAND
// 2: CLOSE_RAND
// 3: CLOSE_LEX
// 4: CLOSE_UNIQUE

#include <map>

using namespace std;

#include "../datastruct.h"
#include "../Cluster/Clusters.h"
#include "PPDTriple.h"

extern float SAMPLE_PERCENT; // .2

// CLOSE_*
extern unsigned QUEUE_SIZE; // number of closest pivots (10)

// CLOSE_UNIQUE
const unsigned UNIQUE_NO=10; // number of unique vectors a query string must generate (10)

class PPDSample 
{
protected:
  Sample sample;
  VectString *data;
  Clusters *clusters;
  ContQueryPivot *query_pivot;

public:
  PPDSample(VectString *d, Clusters *c, ContQueryPivot *q);
  virtual ~PPDSample();

  virtual bool has_next() const=0;
  virtual PPDTriple next()=0;

  static ostream& info(ostream& out);
};

inline PPDSample::PPDSample(VectString *d, Clusters *c, ContQueryPivot *q): data(d), clusters(c), query_pivot(q)
{
}

inline PPDSample::~PPDSample() 
{
}

#endif
