#ifndef _PPDTable_
#define _PPDTable_

#include <iostream>

using namespace std;

#include "PPDEntry.h"

class PPDTable 
{
protected:
  ContPPDEntry *table;
public:
  PPDTable();
  PPDTable(const PPDTable& t);

  ~PPDTable();

  PPDTable& operator=(const PPDTable& t);

  const size_t size_table() const;

  void insert(const PPDEntry& e);
  void erase(const PPDEntry& e);
  void prune_max();

  const ContPPDEntryIt begin_table() const;
  const ContPPDEntryIt end_table() const;
  const ContPPDEntryIt find_table(const PPDEntry& e) const;
  const ContPPDEntryIt lower_bound_table(const PPDEntry& e) const;
  const ContPPDEntryIt upper_bound_table(const PPDEntry& e) const;

#ifdef _Sim_EditVect_
  void serialize(ofstream & out);
  void deserialize(ifstream & in);
#endif

  friend ostream& operator<<(ostream& out, const PPDTable& t);
  friend istream& operator>>(istream& in, PPDTable& t);
};

#endif
