#ifndef _PPDTriple_
#define _PPDTriple_

#include <iostream>
#include <iterator>
#include <list>

using namespace std;

#include "../SimFunc/SimVect.h"

class PPDTriple {
public:
  unsigned query, pivot, str;
  SimVect vect1, vect2;
  SimType dist;

  PPDTriple();
  PPDTriple(unsigned q, unsigned p, unsigned s, SimVect v1, SimVect v2, SimType d);

  friend ostream& operator<<(ostream& out, const PPDTriple& t);
  friend istream& operator>>(istream& in, PPDTriple& t);
  friend bool operator<(const PPDTriple& left, const PPDTriple& right);
};

typedef list<PPDTriple> ListPPDTriple;
typedef ListPPDTriple::iterator ListPPDTripleIt;

//ostream& operator<<(ostream& out, const ListPPDTriple& list) {
//	out<<static_cast<unsigned>(list.size())<<endl<<endl;
//	copy(list.begin(), list.end(), ostream_iterator<PPDTriple>(out, "\n"));
//	return out;
//}
//istream& operator>>(istream& in, ListPPDTriple& list);

inline PPDTriple::PPDTriple(): query(0), pivot(0), str(0), dist(0) {
}

inline PPDTriple::PPDTriple(unsigned q, unsigned p, unsigned s, SimVect v1, SimVect v2, SimType d): query(q), pivot(p), str(s), vect1(v1), vect2(v2), dist(d) {
}

inline ostream& operator<<(ostream& out, const PPDTriple& t) {
  return out<<t.query<<"  "<<t.pivot<<"  "<<t.str<<"  "<<t.vect1<<"  "<<t.vect2<<"  "<<t.dist;
}

inline istream& operator>>(istream& in, PPDTriple& t) {
  return in>>t.query>>t.pivot>>t.str>>t.vect1>>t.vect2>>t.dist;
}

inline bool operator<(const PPDTriple& left, const PPDTriple& right) {
  if (&left==&right)
    return false;
  if (left.query!=right.query)
    return left.query<right.query;
  if (left.pivot!=right.pivot)
    return left.pivot<right.pivot;
  return left.str<right.str;
}

#endif
