#ifndef _Sample_
#define _Sample_

#include <string>
#include <vector>

using namespace std;

class Sample
{
private:
  vector<unsigned> sample;
  vector<unsigned> index;
  unsigned count;
  
public:
  Sample();
  Sample(unsigned max);
  Sample(unsigned number, unsigned max);
  Sample(string file_name);

  vector<unsigned>::const_iterator begin() const;
  vector<unsigned>::const_iterator end() const;  

  unsigned operator[](unsigned idx) const;
  void push_back(unsigned val);
  vector<unsigned>::size_type size() const;
  unsigned get_count() const;

  unsigned generate();
  bool has_next() const;

  void read(string file_name);
  void write(string file_name);

private:
  void init_index(unsigned max);
  void init_rand() const;

  friend ostream& operator<<(ostream& out, const Sample& s);
  friend istream& operator>>(istream& in, Sample& s);
};


inline vector<unsigned>::const_iterator Sample::begin() const
{
  return sample.begin();
}

inline vector<unsigned>::const_iterator Sample::end() const
{
  return sample.end();
}

inline unsigned Sample::operator[](unsigned idx) const
{
  return sample[idx];
}

inline vector<unsigned>::size_type Sample::size() const 
{
  return sample.size();
}

inline vector<unsigned>::size_type Sample::get_count() const 
{
  return count;
}

inline bool Sample::has_next() const
{
  return index.size() != count;
}

#endif
