#include <vector>
#include <set>
#include <iterator>
#include <string>
#include <ctime>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <ctime>

using namespace std;

#include "../setting.h"
#include "../common.h"
#include "SimDist.h"
#include "EditDist.h"
#include "SimVect.h"
#include "../FTable/FEntry.h"
#include "../FTable/FTable.h"
#include "../PPDTable/PPDEntry.h"
#include "../PPDTable/PPDTable.h"
#include "../Cluster/Cluster.h"
#include "../Cluster/Clusters.h"
#include "../FreqEst/Predicate.h"
#include "../FreqEst/FreqEst.h"
#include "../Util.h"

const unsigned EDIT_DIST  = 3;
const unsigned PAIRS_SIZE = 300;

const string FILE_PAIRS="out/pairsED3_J.txt";

typedef vector<float> VectFloat;
typedef VectFloat::iterator VectFloatIt;

int main() 
{
  cout<<fixed<<setprecision(2);

  string
    file_dataset = FILE_PATH + FILE_DATASET,
    file_pairs   = FILE_PATH + FILE_PAIRS;

  srand(static_cast<unsigned>(time(NULL)));

  VectString *d=new VectString;

  read_dataset(d, file_dataset);

  const unsigned data_size = static_cast<unsigned>(d->size());

  time_t ltime;
  time(&ltime);
  srand(static_cast<unsigned int>(ltime));
  float dist = .6;
  for (unsigned i = 0; i < 10; i++) {
    VectString r;
    unsigned a = rand() % data_size;
    Predicate p = Predicate((*d)[a], dist);
    unsigned f = FreqRealFunc(*d,  p,  r);
    cout << "a: " << a << "\td[a]: " << (*d)[a] << "\td: " << dist << "\tf: " << f << endl;
    for (VectStringIt it = r.begin(); it != r.end(); it++) {
      cout << *it << "\te: "<< EditDist((*d)[a], *it) << "\tj: " << JaccDist((*d)[a], *it) << endl;
    }
    cout << endl;
  }

  /*
  VectString vect_1, vect_2;
  VectFloat jacc;
  float sum=0;
  SetUnsigned setIndex;

  while (vect_1.size()<PAIRS_SIZE) {
    unsigned index=rand()%data_size;
    if (setIndex.find(index)==setIndex.end()) {

      icstring a_1=(*d)[index];
      icstring a_2;
      unsigned ed;

//       for (VectStringIt it=d->begin(); it!=d->end(); it++) {
// 	a_2=*it;
// 	if ((ed=EditDist(a_1, a_2))==EDIT_DIST) {
// 	  break;
// 	}
//       }

//       cout<<"a_1:"<<a_1<<endl;

      a_2=a_1;
      while ((ed=EditDist(a_1, a_2))!=EDIT_DIST && ed<2*EDIT_DIST && trim(a_2).length()>2) {
	EditDist_modif(a_2, 1);
      }

//       cout<<endl<<"a_1:"<<a_1<<"\ta_2:"<<a_2<<"\ted:"<<ed<<endl;

      if (ed!=EDIT_DIST) {
	continue;
      }

      setIndex.insert(index);

      float jd=JaccDist(a_1, a_2);

      vect_1.push_back(a_1);
      vect_2.push_back(a_2);
      jacc.push_back(jd);
      sum+=jd;

//       cout<<vect_1.size()<<endl;
    }
  }

  delete d;

  cout<<"writing pairs to file \""<<file_pairs<<"\"..."<< endl; 
  ofstream fout(file_pairs.c_str());
  if (!fout) { cerr<<"can't open output file \""<<file_pairs<<"\""<<endl; exit(EXIT_FAILURE); }
  for (unsigned i=0; i<PAIRS_SIZE; i++) {
    fout<<vect_1[i]<<"\t"<<vect_2[i]<<"\t"<<jacc[i]<<endl;
  }
  cout<<"pairs wrote ("<<PAIRS_SIZE<<")"<<endl;
  
  cout<<"pairs_size:"<<PAIRS_SIZE<<"\tedit_dist:"<<EDIT_DIST<<"\taverage jacc_dist:"<<sum/PAIRS_SIZE<<endl;
  */

  return 0;
}
