#include "EditDist.h"
#include "../dataset.h"
#include "../misc.h"

unsigned EditDist(const icstring& a, const icstring& b) {
  // unsighed char is used because values from 0..255 should be enough
  // uses O(m) space instead of O(nm) as the classic algorithm
  if (a==b) return 0;
  unsigned n, m;
  n=static_cast<unsigned>(a.length());
  m=static_cast<unsigned>(b.length());
  if (n==0) return m;
  if (m==0) return n;
  unsigned i, j, d[2][MAX_STR_LEN], i_prv, i_crt;
  for (j=0; j<=m; j++) d[0][j]=j;
  i_prv=0;
  i_crt=1;
  for (i=1; i<=n; i++) {
    d[i_crt][0]=i;
    for (j=1; j<=m; j++)
      d[i_crt][j]=min(min(
			  d[i_prv][j  ]+1,
			  d[i_crt][j-1]+1),
		      d[i_prv][j-1]+(a[i-1]==b[j-1]?0:1));
    i_prv=i_prv?0:1;
    i_crt=i_crt?0:1;
  }
  return d[i_prv][m];
}

void EditDist_modif(icstring &s_dup, unsigned no_changes) {
  for (unsigned j=0; j<no_changes && trim(s_dup).length()>2; j++) {
    // make one change to s_dup
    const unsigned change=rand()%3;
    /* change:
       0 -> inseriton
       1 -> deletion
       2 -> substitution
    */
//     cout << "j:" << j << " c:" << change << " ";
    string::size_type pos;
    switch (change) {
    case 0: // insertion
      pos=rand()%s_dup.length();
      s_dup.insert(pos, 1, 'a'+static_cast<char>(rand()%('z'-'a'+1)));
      break;
    case 1: // deletion
      pos=rand()%s_dup.length();
      s_dup.erase(pos, 1);
      break;
    case 2: // substitutiion
      pos=rand()%s_dup.length();
      string::size_type pos2=rand()%s_dup.length(); // the positons might be equal!
      const char pos_char=s_dup[pos];
      const char pos2_char=s_dup[pos2];
      s_dup.replace(pos, 1, 1, pos2_char);
      s_dup.replace(pos2, 1, 1, pos_char);
      break;
    }
  }
}
