#ifndef _EditVect_IDS_
#define _EditVect_IDS_

#include "EditDist.h"
#include "../dataset.h"

class EditVect_IDS {
  // < I + D + S >
public:
  unsigned ins_del_sub;

  EditVect_IDS();
  EditVect_IDS(const icstring& a, const icstring& b);

  operator size_t() const;

  unsigned get_dist() const;

  static ostream& info(ostream& out);

  friend ostream& operator<<(ostream& out, const EditVect_IDS& ev);
  friend istream& operator>>(istream& in, EditVect_IDS& ev);
  friend bool operator<(const EditVect_IDS& left, const EditVect_IDS& right);
  friend bool operator!=(const EditVect_IDS& left, const EditVect_IDS& right);
};

inline EditVect_IDS::EditVect_IDS(): ins_del_sub(0) {
}

inline EditVect_IDS::EditVect_IDS(const icstring& a, const icstring& b) 
{
  ins_del_sub=EditDist(a, b);
}

inline EditVect_IDS::operator size_t() const {
  // return as 2 digits
  return static_cast<size_t>(ins_del_sub);
}

inline unsigned EditVect_IDS::get_dist() const {
  return ins_del_sub;
}

inline ostream& operator<<(ostream& out, const EditVect_IDS& ev) {
  return out<<ev.ins_del_sub;
}

inline istream& operator>>(istream& in, EditVect_IDS& ev) {
  return in>>ev.ins_del_sub;
}

inline bool operator<(const EditVect_IDS& left, const EditVect_IDS& right) {
  if (&left==&right)
    return false;
  return left.ins_del_sub<right.ins_del_sub;
}

inline bool operator!=(const EditVect_IDS& left, const EditVect_IDS& right) {
  return left<right || right<left;
}

inline ostream& EditVect_IDS::info(ostream& out)
{
  out << "Metric" << endl << "---" << endl;
  out << "Edit Distnace" << endl;
  out << "Edit Vector\t< I + D + S >" << endl;
  out << "max string len\t" << MAX_STR_LEN << endl;
  return out << endl;
}

#endif
