#ifndef _EditVect_IS_
#define _EditVect_IS_

#include "EditVect.h"
#include "../dataset.h"

class EditVect_IS {
  // < I + S, D >
public:
  unsigned ins_sub, del;

  EditVect_IS();
  EditVect_IS(const icstring& a, const icstring& b);

  operator size_t() const;

  unsigned get_dist() const;

  static ostream& info(ostream& out);

  friend ostream& operator<<(ostream& out, const EditVect_IS& ev);
  friend istream& operator>>(istream& in, EditVect_IS& ev);
  friend bool operator<(const EditVect_IS& left, const EditVect_IS& right);
  friend bool operator!=(const EditVect_IS& left, const EditVect_IS& right);
};

inline EditVect_IS::EditVect_IS(): ins_sub(0), del(0) {
}

inline EditVect_IS::EditVect_IS(const icstring& a, const icstring& b) 
{
  EditVect ev=EditVect(a, b);
  ins_sub=ev.ins+ev.sub;
  del=ev.del;
}

inline EditVect_IS::operator size_t() const {
  // return as 2 digits
  return static_cast<size_t>((ins_sub%10)*10+del%10);
}

inline unsigned EditVect_IS::get_dist() const {
  return ins_sub+del;
}

inline ostream& operator<<(ostream& out, const EditVect_IS& ev) {
  return out<<ev.ins_sub<<' '<<ev.del;
}

inline istream& operator>>(istream& in, EditVect_IS& ev) {
  return in>>ev.ins_sub>>ev.del;
}

inline bool operator<(const EditVect_IS& left, const EditVect_IS& right) {
  if (&left==&right)
    return false;
  if (left.ins_sub!=right.ins_sub)
    return left.ins_sub<right.ins_sub;
  return left.del<right.del;
}

inline bool operator!=(const EditVect_IS& left, const EditVect_IS& right) {
  return left<right || right<left;
}

inline ostream& EditVect_IS::info(ostream& out)
{
  out << "Metric" << endl << "---" << endl;
  out << "Edit Distnace" << endl;
  out << "Edit Vector\t< I + S, D >" << endl;
  out << "max string len\t" << MAX_STR_LEN << endl;
  return out << endl;
}

#endif
