#ifndef _EditVect_S2_
#define _EditVect_S2_

class EditVect_S2 {
  // <I+floor(S/2), D+ceil(S/2)>
public:
  unsigned ins_sub2, del_sub2;

  EditVect_S2();
  EditVect_S2(const icstring& a, const icstring& b);

  operator size_t() const;

  unsigned get_dist() const;

  friend ostream& operator<<(ostream& out, const EditVect_S2& ev);
  friend istream& operator>>(istream& in, EditVect_S2& ev);
  friend bool operator<(const EditVect_S2& left, const EditVect_S2& right);
  friend bool operator!=(const EditVect_S2& left, const EditVect_S2& right);
};

inline EditVect_S2::EditVect_S2(): ins_sub2(0), del_sub2(0) {
}

inline EditVect_S2::EditVect_S2(const icstring& a, const icstring& b) 
{
  EditVect ev=EditVect(a, b);
  ins_sub2=ev.ins+ev.sub/2;
  del_sub2=ev.del+(ev.sub+1)/2;
  
}

inline EditVect_S2::operator size_t() const {
  // return as 2 digits
  return static_cast<size_t>((ins_sub2%10)*10+del_sub2%10);
}

inline unsigned EditVect_S2::get_dist() const {
  return ins_sub2+del_sub2;
}

inline ostream& operator<<(ostream& out, const EditVect_S2& ev) {
  return out<<ev.ins_sub2<<' '<<ev.del_sub2;
}

inline istream& operator>>(istream& in, EditVect_S2& ev) {
  return in>>ev.ins_sub2>>ev.del_sub2;
}

inline bool operator<(const EditVect_S2& left, const EditVect_S2& right) {
  if (&left==&right)
    return false;
  if (left.ins_sub2!=right.ins_sub2)
    return left.ins_sub2<right.ins_sub2;
  return left.del_sub2<right.del_sub2;
}

inline bool operator!=(const EditVect_S2& left, const EditVect_S2& right) {
  return left<right || right<left;
}

#endif
