#include "JaccDist.h"
#include "../dataset.h"

#include <iostream>

using namespace std;

float JaccDist(const icstring& a, const icstring& b) {
  // unsighed char is used because values from 0..255 should be enough
  unsigned n, m;
  n=static_cast<unsigned>(a.length());
  m=static_cast<unsigned>(b.length());
  if (n==0 || m==0) return 1;
  unsigned
    nq, // = n < Q_GRAM? 1:n-Q_GRAM+1, 
    mq; // = m < Q_GRAM? 1:m-Q_GRAM + 1;
  unsigned inte=0, unio=0;
  char aq[MAX_STR_LEN][Q_GRAM+1], bq[MAX_STR_LEN][Q_GRAM+1];
  nq = QGrams(a, aq);
  mq = QGrams(b, bq);
  inte=QGramsInte(aq, nq, bq, mq);
  unio=nq+mq-inte;
  //cout<<(int)unio<<' '<<(int)inte<<'\n';
  return 1-(float)inte/unio;
}

unsigned QGramsInte(char (*aq)[Q_GRAM + 1], unsigned nq, char (*bq)[Q_GRAM + 1], unsigned mq) {
  unsigned i, j, inte=0;
  for (i=0; i<nq; i++)
    for (j=0; j<mq; j++)
      if (strcmp(aq[i], bq[j])==0)
	inte++;
  return inte;
}

unsigned QGrams(const icstring& a, char (*aq)[Q_GRAM + 1]) {
  const unsigned len=static_cast<unsigned>(a.length());
  const unsigned n= len < Q_GRAM? 1 : len - Q_GRAM + 1;
  const char *ac=a.c_str();
  // bag
//   for (unsigned i=0; i<n; i++) {
//     strncpy(aq[i], ac+i, Q_GRAM);
//     aq[i][Q_GRAM]=0;
//   }
  // set
  unsigned k = 0;
  for (unsigned i = 0; i < n; i++) 
    {
      char gram[Q_GRAM + 1];
      strncpy(gram, ac + i, Q_GRAM);
      gram[Q_GRAM]=0;
//       cout << "gram\t" << gram << endl;

      bool not_found = true;
      for (unsigned j = 0; j < k; j++) 
	{
	  if (strcmp(aq[j], gram) == 0) 
	    {
	      not_found = false;
	      break;
	    }
	}
//       cout << "not_found\t" << not_found << endl;
      if (not_found) 
	{
	  strcpy(aq[k], gram);
// 	  cout << "k\t" << k << "\taq[k]\t" << aq[k] << endl;
	  k++;
	}
    }
  return k;
}
