#include "JaccVect.h"
#include "EditDist.h"
#include "../dataset.h"

JaccVect::JaccVect(const icstring& a, const icstring& b): inte(0), unio(0), ed(0) {
	// unsighed char is used because values from 0..255 should be enough
	unsigned n, m;
	n=static_cast<unsigned>(a.length());
	m=static_cast<unsigned>(b.length());
	unsigned nq=n<Q_GRAM?1:n-Q_GRAM+1, mq=m<Q_GRAM?1:m-Q_GRAM+1;
	if (n==0 || m==0) {
		if (n==0) {
			this->unio=mq;
			this->ed=m;
		} else {
			this->unio=nq;
			this->ed=n;
		}
		return;
	}
	char aq[MAX_STR_LEN][Q_GRAM+1], bq[MAX_STR_LEN][Q_GRAM+1];
	QGrams(a, aq);
	QGrams(b, bq);
	this->inte=QGramsInte(aq, nq, bq, mq);
	this->unio=nq+mq-this->inte;
	this->ed=static_cast<unsigned>(EditDist(a, b));
	return;
}

ostream& JaccVect::info(ostream& out)
{
  out << "Metric" << endl << "---" << endl;
  out << "Jacc Distance" << endl;
  out << "Jacc Vector" << endl;
  out << "qgram\t" << Q_GRAM << endl;
  return out << endl;
}
