#include <string>
#include <iostream>
#include <vector>
#include <set>
#include <iterator>

using namespace std;

#include "../common.h"
#include "EditDist.h"
#include "EditVect.h"
#include "EditVect_ID.h"
#include "EditVect_IS.h"
#include "EditVect_DS.h"

int main(int argc, char* argv[]) 
{
  if (argc != 3) {
    string filename = string(argv[0]);
    string::size_type idx = filename.rfind('/');
    if (idx != string::npos) {
      filename=string(filename, idx + 1, filename.length());
    }
    cout << filename << " string string" << endl << "e.g., " << filename << " lucia lucas" << endl;
    return 1;
  }
  
  icstring
    a = icstring(argv[1]),
    b = icstring(argv[2]);

  cout << "edit distance:\t" << EditDist(a, b) << endl;
  cout << "edit vector:\t" << EditVect(a, b) << endl;
  cout << "edit vector ID:\t" << EditVect_ID(a, b) << endl;
  cout << "edit vector IS:\t" << EditVect_IS(a, b) << endl;
  cout << "edit vector DS:\t" << EditVect_DS(a, b) << endl;

  return 0;
}
