(define (edit-distance- a b)
  ; expects lists as arguments
  ; ---
  ; Algorithm
  ; ---
  ; edit_distance("", b) = |b|
  ; edit_distance(a, "") = |a|
  ; edit_distance(a, b)
  ;          = min( edit-distance(a[1..], b[1..]) + (if a[0]==b[0] then 0 else 1),
  ;                 edit-distance(a[0..], b[1..]) + 1,
  ;                 edit-distance(a[1..], b[0..]) + 1)
  ; ---
  ; where:
  ;   |a|    : length of string 'a'
  ;   a[0]   : first char of string 'a'
  ;   a[1..] : sting 'a' without the first char
  ;   a = a[0] + a[1..]
  ; ---
  (if (= (length a) 0)
      (length b)
      (if (= (length b) 0)
          (length a)
          (min (+ (edit-distance- (cdr a) (cdr b))
                  (if (eq? (car a) (car b)) 0 1))
               (+ (edit-distance- a (cdr b))
                  1)
               (+ (edit-distance- (cdr a) b)
                  1)))))

(define (edit-distance a b)
  ; used to convert stirng arguments to list arguments
  (edit-distance- (string->list a) (string->list b)))

(edit-distance "abc" "adc")  ; returns 1
(edit-distance "aaa" "a")    ; returns 2
(edit-distance "abc" "def")  ; returns 3