#include "Util.h"
#include "misc.h"

void read_dataset(VectString *d, string file_dataset) 
{
  icstring s;
  cerr << "...read dataset from file \"" <<last(file_dataset) << "\"" << endl;
  iicfstream fin(file_dataset.c_str());
  if (!fin) { cerr << "can't open input file \"" << file_dataset << "\"" <<endl; exit(EXIT_FAILURE); }
  while (getline(fin, s)) {
    d->push_back(s);
  }
  cout << "Dataset read\t" << d->size() << endl;
}

void read_test(Test& test, string file_test)
{
  cerr << "...read test from file \"" << last(file_test) << "\"..."<< endl; 
  ifstream fin(file_test.c_str());
  if (!fin) { cerr << "can't open input file \"" << file_test << "\"" << endl; exit(EXIT_FAILURE); } 
  fin>>test;
  cout << "Test read\t" << test.size() << endl;
}

void read_query(SetUnsigned& setQuery, string file_query) 
{
  cerr << "...read query from file \"" << last(file_query) << "\""<< endl; 
  ifstream fin(file_query.c_str());
  if (!fin) { cerr << "can't open input file \"" << file_query << "\"" << endl; exit(EXIT_FAILURE); } 
  fin>>setQuery;
  cout << "Query read\t" << setQuery.size() << endl;
}

void read_records(VectRecord & vectRecord, string file_records)
{
  cerr << "...read records from file \"" << last(file_records) << "\""<< endl;
  ifstream fin(file_records.c_str());
  if (!fin) { cerr << "can't open input file \"" << file_records << "\"" << endl; exit(EXIT_FAILURE); }
  fin>>vectRecord;
  cout << "Records read\t" << vectRecord.size() << endl;
}


void write_test(const Test& test, string file_test)
{
  cerr << "...write test to file \"" << last(file_test) << "\"..."<< endl; 
  ofstream fout(file_test.c_str());
  if (!fout) { cerr << "can't open output file \"" << file_test << "\"" << endl; exit(EXIT_FAILURE); }
  fout << test;
  cout << "Test write\t" << test.size() << endl;
}
