#include <iomanip>
#include <sstream>

using namespace std;

#include "misc.h"

icstring trim(const icstring& s) {
  if (s.length()==0)
    return s;
  size_t b=s.find_first_not_of(" \t");
  size_t e=s.find_last_not_of(" \t");

  if (b==icstring::npos) // No non-spaces
    return "";
  return icstring(s, b, e-b+1);
}

string last(string str) 
{
  return "<...>" + str.substr(str.substr(0, str.rfind("/")).rfind("/"));
}

string displayTime(double time) 
{
  ostringstream out;
  int itime = static_cast<int>(time);
  double msec = (time - itime) * 100;
  out << setw(2) << setfill('0') << itime / 3600 << ":";
  itime = itime % 3600;
  out << setw(2) << setfill('0') << itime / 60 << ":";
  itime = itime % 60;
  out << setw(2) << setfill('0') << itime << "." << setw(2) << setfill('0') << msec;
  return out.str();
}
